#### Linux From Scratch - Version 11.1-rc1

### Chapter 8. Installing Basic System Software

- Prev

  Libelf from Elfutils-0.186

- Next

  Python-3.10.2

- Up
- Home

# 8.49. Libffi-3.4.2

The Libffi library provides a portable, high level programming interface to various calling conventions. This allows a programmer to call any function specified by a call interface description at run time.

Approximate build time: 1.9 SBU
Required disk space: 10 MB

## 8.49.1. Installation of Libffi

### Note

Similar to GMP, libffi builds with optimizations specific to the proccesor in use. If building for another system, export CFLAGS and CXXFLAGS to specify a generic build for your architecture. If this is not done, all applications that link to libffi will trigger Illegal Operation Errors.

Prepare libffi for compilation:

    ./configure --prefix=/usr          \
                --disable-static       \
                --with-gcc-arch=native \
                --disable-exec-static-tramp

The meaning of the configure option:

`--with-gcc-arch=native`

  Ensure GCC optimizes for the current system. If this is not specified, the system is guessed and the code generated may not be correct for some systems. If the generated code will be copied from the native system to a less capable system, use the less capable system as a parameter. For details about alternative system types, see the x86 options in the GCC manual.

`--disable-exec-static-tramp`

  Disable static trampoline support. It's a new security feature in libffi, but some BLFS packages (notably GJS and gobject-introspection) have not been adapted for it.

Compile the package:

    make

To test the results, issue:

    make check

Install the package:

    make install

## 8.49.2. Contents of Libffi

Installed library: libffi.so

### Short Descriptions

`libffi` | contains the foreign function interface API functions

- Prev

  Libelf from Elfutils-0.186

- Next

  Python-3.10.2

- Up
- Home